// DO NOT EDIT! This is an autogenerated file. All changes will be
// overwritten!

//	Copyright (c) 2023 Vidyo, Inc. All rights reserved.


namespace VidyoClient
{
	/// <summary>
	/// Indicates the state of the calendar plugin library module, regarding its availability . This includes finding the library, loading the exported interface methods, and then verifying that the version of the library is compatible with the VidyoClient version of the interface it was built against.
	/// </summary>
	public enum CalendarServiceStatus {
		/// <summary>The initial state of the library for a service - ready to be located and loaded.</summary>
		CalendarservicestatusInit,
		/// <summary>Library was loaded and the API function required for registering the interface was found.</summary>
		CalendarservicestatusLoaded,
		/// <summary>Error occurred while trying to load the library.</summary>
		CalendarservicestatusLoadError,
		/// <summary>Library was loaded, but version number does not match the interface that VidyoClient was built against.</summary>
		CalendarservicestatusInvalidVersion,
		/// <summary>Vidyo DLL or static library for specified calendar service could not be found in the installation directory.</summary>
		CalendarservicestatusDllNotFound,
		/// <summary>Unable to retrieve the API function from the Vidyo DLL or static library for specified calendar service.</summary>
		CalendarservicestatusApiProcError,
		/// <summary>Calendar service was loaded, but the 3rd party service it was referencing was not started or was not installed.</summary>
		CalendarservicestatusPluginSvcNotInstalled,
		/// <summary>Calendar service was loaded, and the local 3rd party service is available but not connected to it's resources for event notifications.</summary>
		CalendarservicestatusPluginSvcNotActive,
		/// <summary>Calendar service was loaded, and the local 3rd party service is available but user is not logged in.</summary>
		CalendarservicestatusPluginSvcAuthRequired,
		/// <summary>Calendar service has been uninitialized with all internal resources freed.</summary>
		CalendarservicestatusUnloaded
	}
}
